﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyBoxBlurFilter(img As Image) As Image
	
	Return nativeMe.RunMethod("applyBoxBlurFilter", Array(img))
	
End Sub

'Set the horizontal size of the blur.
'hRadius the radius of the blur in the horizontal direction
'minimum value = 0
public Sub setHRadius(hRadius As Float)

nativeMe.RunMethod("setHRadius", Array(hRadius))

End Sub

'Set the vertical size of the blur.
'vRadius the radius of the blur in the vertical direction
'minimum value = 0
Public Sub setVRadius(vRadius As Float) {
	
nativeMe.RunMethod("setVRadius", Array(vRadius))

End Sub


'Set both the horizontal And vertical sizes of the blur.
'the radius of the blur in both directions
'minimum value = 0
Public Sub setRadius(radius As Float)

nativeMe.RunMethod("setRadius", Array(radius))

End Sub


'Set the number of iterations the blur Is performed.
'iterations the number of iterations
'minimum value = 0
Public Sub setIterations(iterations As Int) 
	
nativeMe.RunMethod("setIterations", Array(iterations))

End Sub
	

#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.BoxBlurFilter;


private float hRadius = 0.0f;
private float vRadius = 0.0f;
private float Radius = 0.0f;
private int iterations = 1;
private boolean premultiplyAlpha = true;

public Image applyBoxBlurFilter(Image img) {

    BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
    BufferedImage srcImage = bmp;
    BoxBlurFilter boxBlurFilter = new BoxBlurFilter();
	
    boxBlurFilter.setRadius(Radius);
    boxBlurFilter.setIterations(iterations);
	boxBlurFilter.setPremultiplyAlpha(true);
	boxBlurFilter.setHRadius(hRadius);
	boxBlurFilter.setVRadius(vRadius);
	
    srcImage = boxBlurFilter.filter(srcImage, srcImage);

    img = SwingFXUtils.toFXImage(srcImage, null);
    return img;
}


	/**
	 * Set the horizontal size of the blur.
	 * @param hRadius the radius of the blur in the horizontal direction
     * @min-value 0
     * @see #getHRadius
	 */
	public void setHRadius(float hRadius) {
		this.hRadius = hRadius;
	}
	
	/**
	 * Get the horizontal size of the blur.
	 * @return the radius of the blur in the horizontal direction
     * @see #setHRadius
	 */
	public float getHRadius() {
		return hRadius;
	}
	
	/**
	 * Set the vertical size of the blur.
	 * @param vRadius the radius of the blur in the vertical direction
     * @min-value 0
     * @see #getVRadius
	 */
	public void setVRadius(float vRadius) {
		this.vRadius = vRadius;
	}
	
	/**
	 * Get the vertical size of the blur.
	 * @return the radius of the blur in the vertical direction
     * @see #setVRadius
	 */
	public float getVRadius() {
		return vRadius;
	}
	
	/**
	 * Set both the horizontal and vertical sizes of the blur.
	 * @param radius the radius of the blur in both directions
     * @min-value 0
     * @see #getRadius
	 */
	public void setRadius(float radius) {
	    this.Radius = radius;
		this.hRadius = this.vRadius = radius;
	}
	
	/**
	 * Get the size of the blur.
	 * @return the radius of the blur in the horizontal direction
     * @see #setRadius
	 */
	public float getRadius() {
		return hRadius;
	}
	
	/**
	 * Set the number of iterations the blur is performed.
	 * @param iterations the number of iterations
     * @min-value 0
     * @see #getIterations
	 */
	public void setIterations(int iterations) {
		this.iterations = iterations;
	}
	
	/**
	 * Get the number of iterations the blur is performed.
	 * @return the number of iterations
     * @see #setIterations
	 */
	public int getIterations() {
		return iterations;
	}

#End If


