﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyCrystallizeFilter(img As Image) As Image
	Return nativeMe.RunMethod("applyCrystallizeFilter", Array(img))
End Sub

'Set the size of the crystals
'Default value is 16
Public Sub setScale(scale As Int) 
	nativeMe.RunMethod("setScale", Array(scale))
End Sub

'Set the edge thickness of the crystals
'Default value is 0.8
Public Sub setEdgeThickness(edgeThickness As Float) 
	nativeMe.RunMethod("setEdgeThickness", Array(edgeThickness))
End Sub

Public Sub setFadeEdges(fadeEdges As Boolean) 
	nativeMe.RunMethod("setFadeEdges", Array(fadeEdges))
End Sub

Public Sub setEdgeColor(edgeColor As Int) 
	nativeMe.RunMethod("setEdgeColor", Array(edgeColor))
End Sub


#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.awt.Graphics2D;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.CrystallizeFilter;
import com.jhlabs.image.ImageMath;
import java.awt.image.*;
import java.awt.*;

private float edgeThickness = 0.8f;
private boolean fadeEdges = false;
private int edgeColor = 0xff000000;
private int scale = 16;

public Image applyCrystallizeFilter(Image img) {

    BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
    BufferedImage srcImage = bmp;
    CrystallizeFilter cf = new CrystallizeFilter();
	
	cf.setScale(scale);
	cf.setEdgeThickness(edgeThickness);
	cf.setFadeEdges(fadeEdges);
	cf.setEdgeColor(edgeColor);

    srcImage = cf.filter(srcImage, srcImage);

    img = SwingFXUtils.toFXImage(srcImage, null);
    return img;
}

public void setScale(int scale) {
   this.scale = scale;
}

public void setEdgeThickness(float edgeThickness) {
	this.edgeThickness = edgeThickness;
}

public float getEdgeThickness() {
	return edgeThickness;
}

public void setFadeEdges(boolean fadeEdges) {
	this.fadeEdges = fadeEdges;
}

public boolean getFadeEdges() {
	return fadeEdges;
}

public void setEdgeColor(int edgeColor) {
	this.edgeColor = edgeColor;
}

public int getEdgeColor() {
	return edgeColor;
}



#End If


