﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyEdgeFilter(img As Image) As Image
	Return nativeMe.RunMethod("applyEdgeFilter", Array(img))
End Sub

public Sub ROBERTS() As String
	Return "ROBERTS"
End Sub

public Sub PREWITT() As String
	Return "PREWITT"
End Sub

public Sub SOBEL() As String
	Return "SOBEL"
End Sub

public Sub FREI_CHEN() As String
	Return "FREI_CHEN"
End Sub

public Sub setVEdgeMatrix(vEdgeMatrix As String)
	nativeMe.RunMethod("setVEdgeMatrix", Array(vEdgeMatrix))
End Sub

public Sub setHEdgeMatrix(hEdgeMatrix As String)
	nativeMe.RunMethod("setHEdgeMatrix", Array(hEdgeMatrix))
End Sub

#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.awt.Graphics2D;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.EdgeFilter;
import com.jhlabs.image.ImageMath;
import java.awt.image.*;
import java.awt.*;
import java.awt.geom.*;

private String edgeFilterHtype = "SOBEL_H";
private String edgeFilterVtype = "SOBEL_V";

private float[] vEdgeMatrix = SOBEL_V;
private float[] hEdgeMatrix = SOBEL_H;
private static float R2 = (float)Math.sqrt(2);

public final static float[] ROBERTS_V = {
	0,  0, -1,
	0,  1,  0,
	0,  0,  0,
};
public final static float[] ROBERTS_H = {
	-1,  0,  0,
	0,  1,  0,
	0,  0,  0,
};
public final static float[] PREWITT_V = {
	-1,  0,  1,
	-1,  0,  1,
	-1,  0,  1,
};
public final static float[] PREWITT_H = {
	-1, -1, -1,
	0,  0,  0,
	1,  1,  1,
};
public final static float[] SOBEL_V = {
	-1,  0,  1,
	-2,  0,  2,
	-1,  0,  1,
};
public static float[] SOBEL_H = {
	-1, -2, -1,
	0,  0,  0,
	1,  2,  1,
};
public final static float[] FREI_CHEN_V = {
	-1,  0,  1,
	-R2,  0,  R2,
	-1,  0,  1,
};
public static float[] FREI_CHEN_H = {
	-1, -R2, -1,
	0,  0,  0,
	1,  R2,  1,
};


public Image applyEdgeFilter(Image img) {

    BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
    BufferedImage srcImage = bmp;
    EdgeFilter ef = new EdgeFilter();
	
	ef.setVEdgeMatrix(vEdgeMatrix);
	ef.setHEdgeMatrix(hEdgeMatrix);
    srcImage = ef.filter(srcImage, srcImage);

    img = SwingFXUtils.toFXImage(srcImage, null);
    return img;
}


public void setVEdgeMatrix(String verticalEdgeMatrix) {
    if (verticalEdgeMatrix.equals("ROBERTS"))
	    this.vEdgeMatrix = ROBERTS_V;
    if (verticalEdgeMatrix.equals("PREWITT"))
	    this.vEdgeMatrix = PREWITT_V;	
    if (verticalEdgeMatrix.equals("SOBEL"))
	    this.vEdgeMatrix = SOBEL_V;		
    if (verticalEdgeMatrix.equals("FREI_CHEN"))
	    this.vEdgeMatrix = FREI_CHEN_V;						
}

public void setHEdgeMatrix(String horizontalEdgeMatrix) {
    if (horizontalEdgeMatrix.equals("ROBERTS"))
	    this.hEdgeMatrix = ROBERTS_H;
    if (horizontalEdgeMatrix.equals("PREWITT"))
	    this.hEdgeMatrix = PREWITT_H;	
    if (horizontalEdgeMatrix.equals("SOBEL"))
	    this.hEdgeMatrix = SOBEL_H;		
    if (horizontalEdgeMatrix.equals("FREI_CHEN"))
	    this.hEdgeMatrix = FREI_CHEN_H;			
}


#End If


