﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyEmbossFilter(img As Image) As Image
	Return nativeMe.RunMethod("applyEmbossFilter", Array(img))
End Sub

Public Sub setAzimuth(azimuth As Float) 
	nativeMe.RunMethod("setAzimuth", Array(azimuth))
End Sub

Public Sub setElevation(elevation As Float) 
	nativeMe.RunMethod("setElevation", Array(elevation))
End Sub

Public Sub setBumpHeight(bumpHeight As Float) 
	nativeMe.RunMethod("setBumpHeight", Array(bumpHeight))
End Sub

Public Sub setEmboss(emboss As Boolean) 
	nativeMe.RunMethod("setEmboss", Array(emboss))
End Sub



#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.awt.Graphics2D;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.EmbossFilter;
import com.jhlabs.image.ImageMath;
import java.awt.image.*;
import java.awt.*;


private final static float pixelScale = 255.9f;
private float azimuth = 135.0f * ImageMath.PI / 180.0f, elevation = 30.0f * ImageMath.PI / 180f;
private boolean emboss = false;
private float width45 = 3.0f;

public Image applyEmbossFilter(Image img) {

    BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
    BufferedImage srcImage = bmp;
    EmbossFilter embossFilter = new EmbossFilter();
	
    embossFilter.setElevation(elevation);
	embossFilter.setAzimuth(azimuth);
	embossFilter.setBumpHeight(width45);
	embossFilter.setEmboss(emboss);
	
    srcImage = embossFilter.filter(srcImage, srcImage);

    img = SwingFXUtils.toFXImage(srcImage, null);
    return img;
}


	public void setAzimuth(float azimuth) {
		this.azimuth = azimuth;
	}
	
	public float getAzimuth() {
		return azimuth;
	}
	
	public void setElevation(float elevation) {
		this.elevation = elevation;
	}
	
	public float getElevation() {
		return elevation;
	}
	
	public void setBumpHeight(float bumpHeight) {
		this.width45 = 3 * bumpHeight;
	}

	public float getBumpHeight() {
		return width45 / 3;
	}

	public void setEmboss(boolean emboss) {
		this.emboss = !emboss;
	}
	
	public boolean getEmboss() {
		return emboss;
	}

#End If


