﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyGammaFilter_1(img As Image) As Image
	Return nativeMe.RunMethod("applyGammaFilter_1", Array(img))
End Sub

public Sub applyGammaFilter_2(img As Image) As Image
	Return nativeMe.RunMethod("applyGammaFilter_2", Array(img))
End Sub


'Set the gamma levels.
'r = the gamma level For the red channel
'g = the gamma level For the blue channel
'b = the gamma level For the green channel
public Sub setGamma_1(r As Float, g As Float, b As Float)
	nativeMe.RunMethod("setGamma_1", Array(r,g,b))
End Sub


public Sub setGamma_2(rgb As Float)
	nativeMe.RunMethod("setGamma_2", Array(rgb))
End Sub

#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.awt.Graphics2D;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.GammaFilter;
import com.jhlabs.image.ImageMath;
import java.awt.image.*;
import java.awt.*;
import java.awt.geom.*;

private float rGamma, gGamma, bGamma, gamma = 0.0f;


    public Image applyGammaFilter_1(Image img) {

      BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
      BufferedImage srcImage = bmp;
      GammaFilter gf = new GammaFilter();
	  gf.setGamma(rGamma, gGamma, bGamma);
	
      srcImage = gf.filter(srcImage, srcImage);

      img = SwingFXUtils.toFXImage(srcImage, null);
      return img;
    }
	
    public Image applyGammaFilter_2(Image img) {

      BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
      BufferedImage srcImage = bmp;
      GammaFilter gf = new GammaFilter();
	  gf.setGamma(gamma);
	
      srcImage = gf.filter(srcImage, srcImage);

      img = SwingFXUtils.toFXImage(srcImage, null);
      return img;
    }	

    /**
     * Set the gamma levels.
     * @param rGamma the gamma level for the red channel
     * @param gGamma the gamma level for the blue channel
     * @param bGamma the gamma level for the green channel
     * @see #getGamma
     */
	public void setGamma_1(float rGamma, float gGamma, float bGamma) {
		this.rGamma = rGamma;
		this.gGamma = gGamma;
		this.bGamma = bGamma;
	}

    /**
     * Set the gamma level.
     * @param gamma the gamma level for all RGB channels
     * @see #getGamma
     */
	public void setGamma_2(float gamma) {
		this.gamma = gamma;
		BA.Log("gamma = " + gamma);
	}
	

#End If


