﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

public Sub applyTwirlFilter(img As Image) As Image
	Return nativeMe.RunMethod("applyTwirlFilter", Array(img))
End Sub

'Set the angle of the twirl in radians
'Default value is 0
Public Sub setAngle(angle As Float) 
	nativeMe.RunMethod("setAngle", Array(angle))
End Sub

'Set radius of the twirl relative to the centre of the image
'Default value is 100
Public Sub setRadius(radius As Float) 
	nativeMe.RunMethod("setRadius", Array(radius))
End Sub




#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.awt.Graphics2D;
import javafx.embed.swing.SwingFXUtils;
import com.jhlabs.image.TwirlFilter;
import com.jhlabs.image.ImageMath;
import java.awt.image.*;
import java.awt.*;
import java.awt.geom.*;

private float angle = 0;
private float centreX = 0.5f;
private float centreY = 0.5f;
private float radius = 100;

private float radius2 = 0;
private float icentreX;
private float icentreY;


public Image applyTwirlFilter(Image img) {

    BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
    BufferedImage srcImage = bmp;
    TwirlFilter tf = new TwirlFilter();
	
	tf.setEdgeAction(1);
	tf.setAngle(angle);
	tf.setRadius(radius);
	
    srcImage = tf.filter(srcImage, srcImage);

    img = SwingFXUtils.toFXImage(srcImage, null);
    return img;
}


	/**
	 * Set the angle of twirl in radians. 0 means no distortion.
	 * @param angle the angle of twirl. This is the angle by which pixels at the nearest edge of the image will move.
     * @see #getAngle
	 */
	public void setAngle(float angle) {
		this.angle = angle;
	}
	
	/**
	 * Get the angle of twist.
	 * @return the angle in radians.
     * @see #setAngle
	 */
	public float getAngle() {
		return angle;
	}
	
	/**
	 * Set the radius of the effect.
	 * @param radius the radius
     * @min-value 0
     * @see #getRadius
	 */
	public void setRadius(float radius) {
		this.radius = radius;
	}

	/**
	 * Get the radius of the effect.
	 * @return the radius
     * @see #setRadius
	 */
	public float getRadius() {
		return radius;
	}


#End If


